/*
 * OpenFairDB API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.9.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import io.swagger.annotations.ApiModel;
import com.google.gson.annotations.SerializedName;

import java.io.IOException;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * A user&#39;s role 
 */
@JsonAdapter(UserRole.Adapter.class)
public enum UserRole {
  
  GUEST("guest"),
  
  USER("user"),
  
  SCOUT("scout"),
  
  ADMIN("admin");

  private String value;

  UserRole(String value) {
    this.value = value;
  }

  public String getValue() {
    return value;
  }

  @Override
  public String toString() {
    return String.valueOf(value);
  }

  public static UserRole fromValue(String value) {
    for (UserRole b : UserRole.values()) {
      if (b.value.equals(value)) {
        return b;
      }
    }
    throw new IllegalArgumentException("Unexpected value '" + value + "'");
  }

  public static class Adapter extends TypeAdapter<UserRole> {
    @Override
    public void write(final JsonWriter jsonWriter, final UserRole enumeration) throws IOException {
      jsonWriter.value(enumeration.getValue());
    }

    @Override
    public UserRole read(final JsonReader jsonReader) throws IOException {
      String value = jsonReader.nextString();
      return UserRole.fromValue(value);
    }
  }
}

